# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from openapi_server.models.base_model_ import Model
from openapi_server.models.affinity import Affinity
from openapi_server.models.container import Container
from openapi_server.models.volume import Volume
from openapi_server import util

from openapi_server.models.affinity import Affinity  # noqa: E501
from openapi_server.models.container import Container  # noqa: E501
from openapi_server.models.volume import Volume  # noqa: E501

class Pod(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, labels=None, annotations=None, containers=None, volumes=None, affinity=None):  # noqa: E501
        """Pod - a model defined in OpenAPI

        :param labels: The labels of this Pod.  # noqa: E501
        :type labels: List[str]
        :param annotations: The annotations of this Pod.  # noqa: E501
        :type annotations: List[str]
        :param containers: The containers of this Pod.  # noqa: E501
        :type containers: List[Container]
        :param volumes: The volumes of this Pod.  # noqa: E501
        :type volumes: List[Volume]
        :param affinity: The affinity of this Pod.  # noqa: E501
        :type affinity: Affinity
        """
        self.openapi_types = {
            'labels': List[str],
            'annotations': List[str],
            'containers': List[Container],
            'volumes': List[Volume],
            'affinity': Affinity
        }

        self.attribute_map = {
            'labels': 'labels',
            'annotations': 'annotations',
            'containers': 'containers',
            'volumes': 'volumes',
            'affinity': 'affinity'
        }

        self._labels = labels
        self._annotations = annotations
        self._containers = containers
        self._volumes = volumes
        self._affinity = affinity

    @classmethod
    def from_dict(cls, dikt) -> 'Pod':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The Pod of this Pod.  # noqa: E501
        :rtype: Pod
        """
        return util.deserialize_model(dikt, cls)

    @property
    def labels(self):
        """Gets the labels of this Pod.

        Map of string keys and values that can be used to organize and categorize (scope and select) objects  # noqa: E501

        :return: The labels of this Pod.
        :rtype: List[str]
        """
        return self._labels

    @labels.setter
    def labels(self, labels):
        """Sets the labels of this Pod.

        Map of string keys and values that can be used to organize and categorize (scope and select) objects  # noqa: E501

        :param labels: The labels of this Pod.
        :type labels: List[str]
        """

        self._labels = labels

    @property
    def annotations(self):
        """Gets the annotations of this Pod.

        An unstructured key value map that can be used to attach arbitrary metadata  # noqa: E501

        :return: The annotations of this Pod.
        :rtype: List[str]
        """
        return self._annotations

    @annotations.setter
    def annotations(self, annotations):
        """Sets the annotations of this Pod.

        An unstructured key value map that can be used to attach arbitrary metadata  # noqa: E501

        :param annotations: The annotations of this Pod.
        :type annotations: List[str]
        """

        self._annotations = annotations

    @property
    def containers(self):
        """Gets the containers of this Pod.


        :return: The containers of this Pod.
        :rtype: List[Container]
        """
        return self._containers

    @containers.setter
    def containers(self, containers):
        """Sets the containers of this Pod.


        :param containers: The containers of this Pod.
        :type containers: List[Container]
        """

        self._containers = containers

    @property
    def volumes(self):
        """Gets the volumes of this Pod.


        :return: The volumes of this Pod.
        :rtype: List[Volume]
        """
        return self._volumes

    @volumes.setter
    def volumes(self, volumes):
        """Sets the volumes of this Pod.


        :param volumes: The volumes of this Pod.
        :type volumes: List[Volume]
        """

        self._volumes = volumes

    @property
    def affinity(self):
        """Gets the affinity of this Pod.


        :return: The affinity of this Pod.
        :rtype: Affinity
        """
        return self._affinity

    @affinity.setter
    def affinity(self, affinity):
        """Sets the affinity of this Pod.


        :param affinity: The affinity of this Pod.
        :type affinity: Affinity
        """

        self._affinity = affinity
